﻿!mod$ v1 sum:4749dcdf2ccf93c6
!need$ ae78003ee30bd742 n mctc_env
module multicharge_blas
use mctc_env,only:sp
use mctc_env,only:dp
use mctc_env,only:ik=>i4
private::sp
private::dp
private::ik
private::sgemv
interface
pure subroutine sgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
character(1_4,1),intent(in)::trans
integer(4),intent(in)::m
integer(4),intent(in)::n
real(4),intent(in)::alpha
integer(4),intent(in)::lda
real(4),intent(in)::a(1_8:int(lda,kind=8),1_8:*)
real(4),intent(in)::x(1_8:*)
integer(4),intent(in)::incx
real(4),intent(in)::beta
real(4),intent(inout)::y(1_8:*)
integer(4),intent(in)::incy
end
end interface
private::dgemv
interface
pure subroutine dgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
character(1_4,1),intent(in)::trans
integer(4),intent(in)::m
integer(4),intent(in)::n
real(8),intent(in)::alpha
integer(4),intent(in)::lda
real(8),intent(in)::a(1_8:int(lda,kind=8),1_8:*)
real(8),intent(in)::x(1_8:*)
integer(4),intent(in)::incx
real(8),intent(in)::beta
real(8),intent(inout)::y(1_8:*)
integer(4),intent(in)::incy
end
end interface
private::ssymv
interface
pure subroutine ssymv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
character(1_4,1),intent(in)::uplo
integer(4),intent(in)::n
real(4),intent(in)::alpha
integer(4),intent(in)::lda
real(4),intent(in)::a(1_8:int(lda,kind=8),1_8:*)
real(4),intent(in)::x(1_8:*)
integer(4),intent(in)::incx
real(4),intent(in)::beta
real(4),intent(inout)::y(1_8:*)
integer(4),intent(in)::incy
end
end interface
private::dsymv
interface
pure subroutine dsymv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
character(1_4,1),intent(in)::uplo
integer(4),intent(in)::n
real(8),intent(in)::alpha
integer(4),intent(in)::lda
real(8),intent(in)::a(1_8:int(lda,kind=8),1_8:*)
real(8),intent(in)::x(1_8:*)
integer(4),intent(in)::incx
real(8),intent(in)::beta
real(8),intent(inout)::y(1_8:*)
integer(4),intent(in)::incy
end
end interface
private::sgemm
interface
pure subroutine sgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
character(1_4,1),intent(in)::transa
character(1_4,1),intent(in)::transb
integer(4),intent(in)::m
integer(4),intent(in)::n
integer(4),intent(in)::k
real(4),intent(in)::alpha
integer(4),intent(in)::lda
real(4),intent(in)::a(1_8:int(lda,kind=8),1_8:*)
integer(4),intent(in)::ldb
real(4),intent(in)::b(1_8:int(ldb,kind=8),1_8:*)
real(4),intent(in)::beta
integer(4),intent(in)::ldc
real(4),intent(inout)::c(1_8:int(ldc,kind=8),1_8:*)
end
end interface
private::dgemm
interface
pure subroutine dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
character(1_4,1),intent(in)::transa
character(1_4,1),intent(in)::transb
integer(4),intent(in)::m
integer(4),intent(in)::n
integer(4),intent(in)::k
real(8),intent(in)::alpha
integer(4),intent(in)::lda
real(8),intent(in)::a(1_8:int(lda,kind=8),1_8:*)
integer(4),intent(in)::ldb
real(8),intent(in)::b(1_8:int(ldb,kind=8),1_8:*)
real(8),intent(in)::beta
integer(4),intent(in)::ldc
real(8),intent(inout)::c(1_8:int(ldc,kind=8),1_8:*)
end
end interface
private::mchrg_sgemv312
private::mchrg_sgemv321
private::mchrg_dgemv312
private::mchrg_dgemv321
private::mchrg_sgemv
private::mchrg_dgemv
private::mchrg_ssymv
private::mchrg_dsymv
private::mchrg_sgemm
private::mchrg_dgemm
private::mchrg_sgemm323
private::mchrg_sgemm233
private::mchrg_sgemm332
private::mchrg_dgemm323
private::mchrg_dgemm233
private::mchrg_dgemm332
interface gemv
procedure::mchrg_sgemv
procedure::mchrg_dgemv
procedure::mchrg_sgemv312
procedure::mchrg_sgemv321
procedure::mchrg_dgemv312
procedure::mchrg_dgemv321
end interface
interface symv
procedure::mchrg_ssymv
procedure::mchrg_dsymv
end interface
interface gemm
procedure::mchrg_sgemm
procedure::mchrg_dgemm
procedure::mchrg_sgemm323
procedure::mchrg_sgemm233
procedure::mchrg_sgemm332
procedure::mchrg_dgemm323
procedure::mchrg_dgemm233
procedure::mchrg_dgemm332
end interface
interface blas_gemv
procedure::sgemv
procedure::dgemv
end interface
private::blas_gemv
interface blas_symv
procedure::ssymv
procedure::dsymv
end interface
private::blas_symv
interface blas_gemm
procedure::sgemm
procedure::dgemm
end interface
private::blas_gemm
contains
subroutine mchrg_sgemv312(amat,xvec,yvec,alpha,beta,trans)
real(4),contiguous,intent(in),target::amat(:,:,:)
real(4),intent(in)::xvec(:)
real(4),contiguous,intent(inout),target::yvec(:,:)
real(4),intent(in),optional::alpha
real(4),intent(in),optional::beta
character(1_4,1),intent(in),optional::trans
end
subroutine mchrg_sgemv321(amat,xvec,yvec,alpha,beta,trans)
real(4),contiguous,intent(in),target::amat(:,:,:)
real(4),contiguous,intent(in),target::xvec(:,:)
real(4),intent(inout)::yvec(:)
real(4),intent(in),optional::alpha
real(4),intent(in),optional::beta
character(1_4,1),intent(in),optional::trans
end
subroutine mchrg_dgemv312(amat,xvec,yvec,alpha,beta,trans)
real(8),contiguous,intent(in),target::amat(:,:,:)
real(8),intent(in)::xvec(:)
real(8),contiguous,intent(inout),target::yvec(:,:)
real(8),intent(in),optional::alpha
real(8),intent(in),optional::beta
character(1_4,1),intent(in),optional::trans
end
subroutine mchrg_dgemv321(amat,xvec,yvec,alpha,beta,trans)
real(8),contiguous,intent(in),target::amat(:,:,:)
real(8),contiguous,intent(in),target::xvec(:,:)
real(8),intent(inout)::yvec(:)
real(8),intent(in),optional::alpha
real(8),intent(in),optional::beta
character(1_4,1),intent(in),optional::trans
end
pure subroutine mchrg_sgemv(amat,xvec,yvec,alpha,beta,trans)
real(4),intent(in)::amat(:,:)
real(4),intent(in)::xvec(:)
real(4),intent(inout)::yvec(:)
real(4),intent(in),optional::alpha
real(4),intent(in),optional::beta
character(1_4,1),intent(in),optional::trans
end
pure subroutine mchrg_dgemv(amat,xvec,yvec,alpha,beta,trans)
real(8),intent(in)::amat(:,:)
real(8),intent(in)::xvec(:)
real(8),intent(inout)::yvec(:)
real(8),intent(in),optional::alpha
real(8),intent(in),optional::beta
character(1_4,1),intent(in),optional::trans
end
pure subroutine mchrg_ssymv(amat,xvec,yvec,uplo,alpha,beta)
real(4),intent(in)::amat(:,:)
real(4),intent(in)::xvec(:)
real(4),intent(inout)::yvec(:)
character(1_4,1),intent(in),optional::uplo
real(4),intent(in),optional::alpha
real(4),intent(in),optional::beta
end
pure subroutine mchrg_dsymv(amat,xvec,yvec,uplo,alpha,beta)
real(8),intent(in)::amat(:,:)
real(8),intent(in)::xvec(:)
real(8),intent(inout)::yvec(:)
character(1_4,1),intent(in),optional::uplo
real(8),intent(in),optional::alpha
real(8),intent(in),optional::beta
end
pure subroutine mchrg_sgemm(amat,bmat,cmat,transa,transb,alpha,beta)
real(4),intent(in)::amat(:,:)
real(4),intent(in)::bmat(:,:)
real(4),intent(inout)::cmat(:,:)
character(1_4,1),intent(in),optional::transa
character(1_4,1),intent(in),optional::transb
real(4),intent(in),optional::alpha
real(4),intent(in),optional::beta
end
pure subroutine mchrg_dgemm(amat,bmat,cmat,transa,transb,alpha,beta)
real(8),intent(in)::amat(:,:)
real(8),intent(in)::bmat(:,:)
real(8),intent(inout)::cmat(:,:)
character(1_4,1),intent(in),optional::transa
character(1_4,1),intent(in),optional::transb
real(8),intent(in),optional::alpha
real(8),intent(in),optional::beta
end
subroutine mchrg_sgemm323(amat,bmat,cmat,transa,transb,alpha,beta)
real(4),contiguous,intent(in),target::amat(:,:,:)
real(4),intent(in)::bmat(:,:)
real(4),contiguous,intent(inout),target::cmat(:,:,:)
character(1_4,1),intent(in),optional::transa
character(1_4,1),intent(in),optional::transb
real(4),intent(in),optional::alpha
real(4),intent(in),optional::beta
end
subroutine mchrg_sgemm233(amat,bmat,cmat,transa,transb,alpha,beta)
real(4),intent(in)::amat(:,:)
real(4),contiguous,intent(in),target::bmat(:,:,:)
real(4),contiguous,intent(inout),target::cmat(:,:,:)
character(1_4,1),intent(in),optional::transa
character(1_4,1),intent(in),optional::transb
real(4),intent(in),optional::alpha
real(4),intent(in),optional::beta
end
subroutine mchrg_sgemm332(amat,bmat,cmat,transa,transb,alpha,beta)
real(4),contiguous,intent(in),target::amat(:,:,:)
real(4),contiguous,intent(in),target::bmat(:,:,:)
real(4),intent(inout)::cmat(:,:)
character(1_4,1),intent(in),optional::transa
character(1_4,1),intent(in),optional::transb
real(4),intent(in),optional::alpha
real(4),intent(in),optional::beta
end
subroutine mchrg_dgemm323(amat,bmat,cmat,transa,transb,alpha,beta)
real(8),contiguous,intent(in),target::amat(:,:,:)
real(8),intent(in)::bmat(:,:)
real(8),contiguous,intent(inout),target::cmat(:,:,:)
character(1_4,1),intent(in),optional::transa
character(1_4,1),intent(in),optional::transb
real(8),intent(in),optional::alpha
real(8),intent(in),optional::beta
end
subroutine mchrg_dgemm233(amat,bmat,cmat,transa,transb,alpha,beta)
real(8),intent(in)::amat(:,:)
real(8),contiguous,intent(in),target::bmat(:,:,:)
real(8),contiguous,intent(inout),target::cmat(:,:,:)
character(1_4,1),intent(in),optional::transa
character(1_4,1),intent(in),optional::transb
real(8),intent(in),optional::alpha
real(8),intent(in),optional::beta
end
subroutine mchrg_dgemm332(amat,bmat,cmat,transa,transb,alpha,beta)
real(8),contiguous,intent(in),target::amat(:,:,:)
real(8),contiguous,intent(in),target::bmat(:,:,:)
real(8),intent(inout)::cmat(:,:)
character(1_4,1),intent(in),optional::transa
character(1_4,1),intent(in),optional::transb
real(8),intent(in),optional::alpha
real(8),intent(in),optional::beta
end
end
