﻿!mod$ v1 sum:f1b49386d60f378b
!need$ ae78003ee30bd742 n mctc_env
!need$ 880c3f35e6e2ea39 n mctc_io
!need$ a81f69dbc3491e13 n mctc_io_constants
!need$ caad3462fe6207cd n mctc_io_math
!need$ 4749dcdf2ccf93c6 n multicharge_blas
!need$ d625821800b83a90 n multicharge_cutoff
!need$ 5696849062f74923 n multicharge_ewald
!need$ 21a7fe28106e0255 n multicharge_lapack
!need$ 7907478ec2a3cd63 n multicharge_wignerseitz
module multicharge_model
use mctc_env,only:error_type
use mctc_env,only:wp
use mctc_env,only:ik=>i4
use mctc_io,only:structure_type
use mctc_io_constants,only:pi
use mctc_io_math,only:matdet_3x3
use mctc_io_math,only:matinv_3x3
use multicharge_blas,only:gemv
use multicharge_blas,only:symv
use multicharge_blas,only:gemm
use multicharge_cutoff,only:get_lattice_points
use multicharge_ewald,only:get_alpha
use multicharge_lapack,only:sytrf
use multicharge_lapack,only:sytrs
use multicharge_lapack,only:sytri
use multicharge_wignerseitz,only:wignerseitz_cell_type
use multicharge_wignerseitz,only:new_wignerseitz_cell
use multicharge_blas,only:multicharge_blas$multicharge_blas$mchrg_dgemv312=>mchrg_dgemv312
use multicharge_blas,only:multicharge_blas$multicharge_blas$mchrg_dsymv=>mchrg_dsymv
use multicharge_blas,only:multicharge_blas$multicharge_blas$mchrg_dgemm323=>mchrg_dgemm323
use multicharge_cutoff,only:multicharge_cutoff$multicharge_cutoff$get_lattice_points_rep_3d=>get_lattice_points_rep_3d
use multicharge_lapack,only:multicharge_lapack$multicharge_lapack$mchrg_dsytrf=>mchrg_dsytrf
use multicharge_lapack,only:multicharge_lapack$multicharge_lapack$mchrg_dsytrs1=>mchrg_dsytrs1
use multicharge_lapack,only:multicharge_lapack$multicharge_lapack$mchrg_dsytri=>mchrg_dsytri
private::error_type
private::wp
private::ik
private::structure_type
private::pi
private::matdet_3x3
private::matinv_3x3
private::gemv
private::symv
private::gemm
private::get_lattice_points
private::get_alpha
private::sytrf
private::sytrs
private::sytri
private::wignerseitz_cell_type
private::new_wignerseitz_cell
private::multicharge_blas$multicharge_blas$mchrg_dgemv312
private::multicharge_blas$multicharge_blas$mchrg_dsymv
private::multicharge_blas$multicharge_blas$mchrg_dgemm323
private::multicharge_cutoff$multicharge_cutoff$get_lattice_points_rep_3d
private::multicharge_lapack$multicharge_lapack$mchrg_dsytrf
private::multicharge_lapack$multicharge_lapack$mchrg_dsytrs1
private::multicharge_lapack$multicharge_lapack$mchrg_dsytri
type::mchrg_model_type
real(8),allocatable::rad(:)
real(8),allocatable::chi(:)
real(8),allocatable::eta(:)
real(8),allocatable::kcn(:)
contains
procedure::solve
end type
real(8),parameter,private::twopi=6.28318530717958623199592693708837032318115234375_8
real(8),parameter,private::sqrtpi=1.772453850905515881919427556567825376987457275390625_8
intrinsic::sqrt
private::sqrt
real(8),parameter,private::sqrt2pi=7.9788456080286540572643616542336530983448028564453125e-1_8
real(8),parameter,private::eps=1.490116119384765625e-8_8
intrinsic::epsilon
private::epsilon
private::get_vrhs
private::get_dir_trans
private::get_rec_trans
private::get_amat_0d
private::get_amat_3d
private::get_amat_dir_3d
private::get_amat_rec_3d
private::get_damat_0d
private::get_damat_3d
private::get_damat_dir_3d
private::get_damat_rec_3d
private::solve
contains
subroutine new_mchrg_model(self,chi,rad,eta,kcn)
type(mchrg_model_type),intent(out)::self
real(8),intent(in)::chi(:)
real(8),intent(in)::rad(:)
real(8),intent(in)::eta(:)
real(8),intent(in)::kcn(:)
end
subroutine get_vrhs(self,mol,cn,xvec,dxdcn)
type(mchrg_model_type),intent(in)::self
type(structure_type),intent(in)::mol
real(8),intent(in)::cn(:)
real(8),intent(out)::xvec(:)
real(8),intent(out),optional::dxdcn(:)
end
subroutine get_dir_trans(lattice,trans)
real(8),intent(in)::lattice(:,:)
real(8),allocatable,intent(out)::trans(:,:)
end
subroutine get_rec_trans(lattice,trans)
real(8),intent(in)::lattice(:,:)
real(8),allocatable,intent(out)::trans(:,:)
end
subroutine get_amat_0d(self,mol,amat)
type(mchrg_model_type),intent(in)::self
type(structure_type),intent(in)::mol
real(8),intent(out)::amat(:,:)
end
subroutine get_amat_3d(self,mol,wsc,alpha,amat)
type(mchrg_model_type),intent(in)::self
type(structure_type),intent(in)::mol
type(wignerseitz_cell_type),intent(in)::wsc
real(8),intent(in)::alpha
real(8),intent(out)::amat(:,:)
end
subroutine get_amat_dir_3d(rij,gam,alp,trans,amat)
real(8),intent(in)::rij(1_8:3_8)
real(8),intent(in)::gam
real(8),intent(in)::alp
real(8),intent(in)::trans(:,:)
real(8),intent(out)::amat
end
subroutine get_amat_rec_3d(rij,vol,alp,trans,amat)
real(8),intent(in)::rij(1_8:3_8)
real(8),intent(in)::vol
real(8),intent(in)::alp
real(8),intent(in)::trans(:,:)
real(8),intent(out)::amat
end
subroutine get_damat_0d(self,mol,qvec,dadr,dadl,atrace)
type(mchrg_model_type),intent(in)::self
type(structure_type),intent(in)::mol
real(8),intent(in)::qvec(:)
real(8),intent(out)::dadr(:,:,:)
real(8),intent(out)::dadl(:,:,:)
real(8),intent(out)::atrace(:,:)
end
subroutine get_damat_3d(self,mol,wsc,alpha,qvec,dadr,dadl,atrace)
type(mchrg_model_type),intent(in)::self
type(structure_type),intent(in)::mol
type(wignerseitz_cell_type),intent(in)::wsc
real(8),intent(in)::alpha
real(8),intent(in)::qvec(:)
real(8),intent(out)::dadr(:,:,:)
real(8),intent(out)::dadl(:,:,:)
real(8),intent(out)::atrace(:,:)
end
subroutine get_damat_dir_3d(rij,gam,alp,trans,dg,ds)
real(8),intent(in)::rij(1_8:3_8)
real(8),intent(in)::gam
real(8),intent(in)::alp
real(8),intent(in)::trans(:,:)
real(8),intent(out)::dg(1_8:3_8)
real(8),intent(out)::ds(1_8:3_8,1_8:3_8)
end
subroutine get_damat_rec_3d(rij,vol,alp,trans,dg,ds)
real(8),intent(in)::rij(1_8:3_8)
real(8),intent(in)::vol
real(8),intent(in)::alp
real(8),intent(in)::trans(:,:)
real(8),intent(out)::dg(1_8:3_8)
real(8),intent(out)::ds(1_8:3_8,1_8:3_8)
end
subroutine solve(self,mol,cn,dcndr,dcndl,energy,gradient,sigma,qvec,dqdr,dqdl)
class(mchrg_model_type),intent(in)::self
type(structure_type),intent(in)::mol
real(8),contiguous,intent(in)::cn(:)
real(8),contiguous,intent(in),optional::dcndr(:,:,:)
real(8),contiguous,intent(in),optional::dcndl(:,:,:)
real(8),contiguous,intent(inout),optional::energy(:)
real(8),contiguous,intent(inout),optional::gradient(:,:)
real(8),contiguous,intent(inout),optional::sigma(:,:)
real(8),contiguous,intent(out),optional::qvec(:)
real(8),contiguous,intent(out),optional::dqdr(:,:,:)
real(8),contiguous,intent(out),optional::dqdl(:,:,:)
end
end
